=== debian/changelog ===
libsbml (5.17.2+dfsg-3) unstable; urgency=medium

  * Fix link in development package
    Closes: #920849

 -- Andreas Tille <tille@debian.org>  Wed, 30 Jan 2019 19:17:03 +0100

libsbml (5.17.2+dfsg-2) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * Add missing Breaks+Replaces: libsbml5-python-doc
    Closes: #919794

  [ Michael R. Crusoe ]
  * Fix build for multiarch cross building (specifically i386 on amd64)
  * Link to jquery and other assets from the default-jdk-doc
  * Slim build-deps (637 → 595) use jdk-headless

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sat, 19 Jan 2019 23:39:33 -0800

libsbml (5.17.2+dfsg-1) unstable; urgency=medium

  [ gregor herrmann ]
  * Fix Perl installdir
    Closes: #896531

  [ Andreas Tille ]
  * New upstream version
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.3.0
  * debhelper 12
  * Deal with issue in doclets by removing docs/src/SBMLDoclet.java
  * Remove libsbml-java-doc since doc does not build properly
    Closes: #901455, #911482
  * Provide Python3 instead of Python2 bindings (SBML can only provide
    either Python2 or Python3 - lets do the switch now)
    Closes: #847013
  * Secure URI in copyright format
  * Drop useless get-orig-source target
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target
  * Remove trailing whitespace in debian/changelog
  * Do not parse d/changelog
  * Build-Depends: libnewlib-dev, check
  * Remove Matlab related options from debian/cmake_opts (thanks for the
    hint to Nicolas Mora)
  * WITH_R=off (we do not build an R package and something is wrong with
    the R build)
  * Do not provide Java doc since there are errors when creating it
    and this solution was suggested by the Debian Java team
  * Fix Perl interpreter path
  * d/copyright: examples have MIT license

 -- Andreas Tille <tille@debian.org>  Thu, 17 Jan 2019 12:12:21 +0100

libsbml (5.16.0+dfsg-2) unstable; urgency=medium

  * Work around javadoc issue with Java 9
    Closes: #893298

 -- Andreas Tille <tille@debian.org>  Sun, 18 Mar 2018 19:49:01 +0100
